
import java.awt.Button;
import java.awt.BorderLayout;
import java.awt.Color;
import java.awt.Dimension;
import java.awt.Frame;
import java.awt.Graphics;
import java.awt.Image;
import java.awt.Label;
import java.awt.Panel;
import java.awt.Point;
import java.awt.TextArea;
import java.awt.TextField;
import java.awt.Toolkit;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.KeyEvent;
import java.awt.event.KeyListener;
import java.awt.event.WindowAdapter;
import java.awt.event.WindowEvent;
//Ʈ ȭ Ŭ
public class Tetris implements KeyListener {
	
	private int screenSizeWidth;
	private int screenSizeheight;
	
	final TetrisGame 				fGame      	        = new TetrisGame();
	final TetrisBoardGUI 			fBoardGUI		    = new TetrisBoardGUI();
	final TempTetrisBoardGUI  fTempBoardGUI = new TempTetrisBoardGUI();
	final TextAreaGui              fTextAreaGUI    = new TextAreaGui();
	final Frame						 tFrame             = new Frame("Ʈ");
	final Button tStartButton                       = new Button("Start");
	final Label fLabelScore                          = new Label(" : ");
	final Panel fGUIPanel                             = new Panel(new BorderLayout());
	final Panel fTempGUIPanel                     = new Panel();
	final Toolkit tk= Toolkit.getDefaultToolkit();
	final Dimension screenSize=tk.getScreenSize();
	
	//Ʈũ ӽ awt
	final Label fL1 = new Label(" :");
	final TextField fTF1 = new TextField();
	final TextArea fTA1 =new TextArea("ƮԴϴ.\n",10,50,TextArea.SCROLLBARS_VERTICAL_ONLY);
	final Button fB1 =new Button("Host");
	final Button fB2 =new Button("Join");
	
	
	Tetris(){//
		   	
		setScreenSize(screenSize.width,screenSize.height);
		tFrame.setLayout(null);
		tFrame.setSize(screenSizeWidth/2,screenSizeheight-(screenSizeheight/4));
		tFrame.setLocation(screenSizeWidth/4, screenSizeheight/5-100);
		
		tStartButton.setSize(50,25);
		tStartButton.setLocation(500, 700);
		
		
		//Ʈũ awt ̿ϼ
		tFrame.add(fL1);
		fL1.setSize(50, 50);
		fL1.setLocation(400,600);
		tFrame.add(fTF1);
		fTF1.setSize(95,20);
		fTF1.setLocation(450, 613);
		tFrame.add(fTextAreaGUI);
		fTextAreaGUI.setSize(250,250);
		fTextAreaGUI.setLocation(350, 300);
		tFrame.add(fB1);
		fB1.setSize(50,25);
		fB1.setLocation(400, 645);
		tFrame.add(fB2);
		fB2.setSize(50,25);
		fB2.setLocation(475, 645);
		
		// ̸ ȭ
		fTempBoardGUI.setSize(200, 200);
		fTempBoardGUI.setLocation(400,50);
		
		//fGUIPanel.setBackground(Color.gray); // Gui
		fGUIPanel.setLocation(10,35);
		fGUIPanel.setSize(300, 715);
		
		fTempGUIPanel.setBackground(Color.gray);//ο ǽ Gui
		fTempGUIPanel.setLocation(400,50);
		//fTempGUIPanel.setPreferredSize(new java.awt.Dimension(200, 200));
		fTempGUIPanel.setSize(150, 150);
		//fBoardGUI.setLocation(50,50);
		//tFrame.add(tStartButton,"South");
		//tFrame.add(fBoardGUI,"Center");
		//tFrame.add(fScore,"East");
		
		
		
		
		//@@@@@@@@@@@@@@@@@@@@@@@@@@
		final int width   = tFrame.getBounds().width;
    	final int height  = tFrame.getBounds().height;
    	System.out.println("width="+width+" height="+height);//̳ũ Ȯο
    	
    	
		tFrame.add(fGUIPanel);
		tFrame.add(fTempBoardGUI);
		fGUIPanel.add(fBoardGUI,"Center");
		fGUIPanel.add(fLabelScore,"North");
	
		
		
		//fTempGUIPanel.add(fTempBoardGUI);
		tFrame.add(tStartButton);
		
		fGame.addTextListener(fTextAreaGUI);
		fGame.addBoardListener(fBoardGUI);
		fGame.addTempBoardListener(fTempBoardGUI);
		
		tFrame.addKeyListener(this);
		//tFrame.pack();
		tFrame.setVisible(true);
		
		// 
		fGame.addScoreListener(new ScoreListener()
		{
			public void scoreChange(BoardEvent e)
			{
				fLabelScore.setText(" : " + e.getSource());
			}
		});		
				
		//۹ư
		tStartButton.addActionListener(new ActionListener()
        {
            public void actionPerformed(ActionEvent e)
            {	
               fGame.startGame();
               tFrame.requestFocus();
                
            }
        });
		//ȣƮư
		fB1.addActionListener(new ActionListener()//host
        {
            public void actionPerformed(ActionEvent e)
            {	
               fGame.startHostGame();
               tFrame.requestFocus();
                
            }
        });
		//ιư
		fB2.addActionListener(new ActionListener()
        {
            public void actionPerformed(ActionEvent e)
            {	
               fGame.startClient();
               tFrame.requestFocus();
                
            }
        });
		//
		tFrame.addWindowListener(new WindowAdapter()
        {
            public void windowClosing(WindowEvent e)
            {
                System.exit(0);
            }
        });
	}
	
	
	public static void main(String[] args) {
		// TODO Auto-generated method stub
		new Tetris();
					
	}
	
	
	public void keyPressed(KeyEvent e) {
		
		switch (e.getKeyCode()) 
    	{
        	case KeyEvent.VK_LEFT  :  fGame.move(TetrisPiece.LEFT);
        	                         break;
        	case KeyEvent.VK_RIGHT : fGame.move(TetrisPiece.RIGHT);
        	                         break;
        	case KeyEvent.VK_UP    : fGame.move(TetrisPiece.ROTATE);
        	                         break;
        	case KeyEvent.VK_DOWN  : fGame.move(TetrisPiece.DOWN);
        	                         break;
            case KeyEvent.VK_SHIFT : fGame.move(TetrisPiece.FALL);
    	}
		
	}
	public void keyTyped(KeyEvent e) {}
	public void keyReleased(KeyEvent e) {}
	
	public void setScreenSize(int width,int height){
		screenSizeWidth = width;
		screenSizeheight = height;
	}
	//@@@@@@@@@@@@@@@@@@@@@@
	//@		        TextAreaGUI
	//@
	public class TextAreaGui extends TextArea implements TextListener
	{
		TextAreaGui(){
			
			super("ƮԴϴ.\n",10,50,TextArea.SCROLLBARS_VERTICAL_ONLY);
		
		}
		public void TextChange(BoardEvent e) {
			
			append((String)e.getSource()+"\n");
			
		}
	}
	
	//@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
	//@
	//@  			 TempTetrisBoardGUI
	//@
	public class TempTetrisBoardGUI extends Panel implements BoardListener{
		
		private TetrisPiece fTempPiece;
		
		
		public void boardChange(BoardEvent e) {
			
			fTempPiece = (TetrisPiece)e.getSource();   
            repaint();
		}
		
		
		public void paint(Graphics graphics){
		
			final int width   = getBounds().width;
	    	final int height  = getBounds().height;
						
            final Image    image = createImage(width, height);
            final Graphics g       = image.getGraphics();  
            
            //System.out.println("TempTetrisBoardGUI width="+width);
	    	//System.out.println("TempTetrisBoardGUI height="+height);
            
            if(fTempPiece!=null){
				
            	final int numCols = 4;//y
                final int numRows = 4;//x
			
				//final Point center=fTempPiece.getCentrePoint();
				final Point[] blocks=fTempPiece.getRelativePoints();
			
		
		                        
				for(int cols =0;cols<numCols;cols++){//y
					for(int rows =0;rows<numRows;rows++){//x
    			    			
    				g.setColor(fBoardGUI.getGetPieceColor());			
    				drawBlock(g,width/numRows*(blocks[rows].x+1),height/numCols*(blocks[rows].y+1), width/numRows, height/numCols);
    				   				
					}
				}
		
    				g.setColor(Color.blue);
    				g.drawRect(0, 0, width-1, height-1);    
    				graphics.drawImage(image, 0, 0, width, height, null);
		       
            }//if
		}
		private void drawBlock(Graphics g, int x, int y, int width, int height)
		//ġ,ġ,ũ,ũ
        {				
			g.fillRect(x+2, y+2, width-3, height-3);
			g.setColor(Color.black);
            g.drawRect(x, y, width, height);
        }
        
	}
	
	//@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
	//@
	//@  			 TetrisBoardGUI
	//@
	public class TetrisBoardGUI extends Panel implements BoardListener{
						
		private TetrisBoard fBoard;
				
		public void boardChange(BoardEvent e)
        {
			
    	    fBoard = (TetrisBoard)e.getSource();   
            repaint();
            
        }
		
		public void paint(Graphics graphics){
					
			
			final int width   = getBounds().width;
	    	final int height  = getBounds().height;
	    	
	    	//System.out.println("TetrisBoardGUI width="+width);
	    	//System.out.println("TetrisBoardGUI height="+height);
	    	//System.out.println("width/10="+width/10);
	    	//System.out.println("height/20="+height/20);
	    		    	
	    	final Image    image = createImage(width, height);
	        final Graphics g     = image.getGraphics();  
	                    
	        if(fBoard!=null){
	        
	        final int numCols = fBoard.getColumns();//y
            final int numRows = fBoard.getRows();//x
            
            //System.out.println("Columns = "+ fBoard.getColumns());
	    	//System.out.println("Rows = "+fBoard.getRows());
            //System.out.println("width="+width+" height="+height);//̳ũ Ȯο
            
	    	for(int cols =0;cols<numCols;cols++){
	    		for(int rows =0;rows<numRows;rows++){
	    			
	    			final int piece= fBoard.getPieceAt(cols, rows);
	    				
	    			if(fBoard.getPieceAt(cols, rows)!=fBoard.EMPTY_BLOCK)
	    			{
	    				g.setColor(getPieceColor(piece));			
	    				drawBlock(g,width/numRows*rows,height/numCols*cols, width/numRows, height/numCols);
	    				//System.out.println(width/numRows*rows);
	    				//System.out.println(height/numCols*cols);
	    			}
	    		}
	    	}
	    	g.setColor(Color.blue);
	        g.drawRect(0, 0, width-1, height-1);    
			graphics.drawImage(image, 0, 0, width, height, null);
			}
		}
		
		private void drawBlock(Graphics g, int x, int y, int width, int height)//ġ,ġ,ũ,ũ
        {				
			g.fillRect(x+2, y+2, width-3, height-3);
			g.setColor(Color.black);
            g.drawRect(x, y, width, height);
        }
		
		public Dimension getPreferredSize()//ʿ  ſ
        {
            return new Dimension(400, 800);
        }
		
		public Color getGetPieceColor(){// ǽ Color return
			return getPieceColor(fGame.getTempPiecefType());
		}
		
		private Color getPieceColor(int color)//Tetris Color
        {
        	Color result = null;
        
        	switch (color) 
        	{
            	case TetrisPiece.L_PIECE : result = new Color(24, 105, 198);  // turquoise
            	                           break;
            	case TetrisPiece.J_PIECE : result = new Color(206, 56, 173);  // purple
                                           break;
            	case TetrisPiece.I_PIECE : result = new Color(41, 40, 206);   // blue
            	                           break;
            	case TetrisPiece.Z_PIECE : result = new Color(212, 0, 0);     // red
            	                           break;
            	case TetrisPiece.S_PIECE : result = new Color(82, 154, 16);   // green
            	                           break;
            	case TetrisPiece.O_PIECE : result = new Color(123, 121, 123); // gray
            	                           break;
            	case TetrisPiece.T_PIECE : result = new Color(156, 142, 8);   // yellow
            	                           break;
        	}
        
        	return result;
        }
	}

}
