import java.awt.Point;
import java.util.Vector;

public class TetrisGame {
	
	private GameNetworkModule 	 fNetwork;//Ʈũ 
	private EventHandler			 fEventHandler;//,ؽƮƷ,GUI
	private TetrisBoard  			 fBoard;//
    private TetrisPiece  			 fCurrPiece;//ǽ
    private TetrisPiece  			 fTempCurrPiece;//ǽ
    private GameThread  		 fGameRunnable;
    
    private float 			fDelay;//ӵ
    private int				fScore;//
    private int				fLine;// ټ
    private boolean     	fPlaying;//on/off
    private boolean     	fNetPlaying;//Ʈũon/off
    private boolean		fGameReady;
    //private boolean		fReady;//׽Ʈ
        
    
    public TetrisGame()// ʱȭ
    {	
    	fGameRunnable = new GameThread();
    	fEventHandler   = new EventHandler();//
    	fBoard              = new TetrisBoard(10,20);// 20 X 10
    	fPlaying            = false;// off
    	fNetPlaying       = false;//Ʈũ off
    	fGameReady     = true;// غ on
    	
    }
    public void startGame(){//ȥϱ
    	//ǽ,ǽNullʱȭ,fPlaying,fDelay,fScore 
    	// , Thread ,ŸƮ 
    	// ƴҽ ۵
    	
    	System.gc();
    	
    	if(fPlaying == false )
    	{
    		fTempCurrPiece = TetrisPiece.getRandomPiece(fBoard);// ǽ 
    		fCurrPiece		    = null;
    		fPlaying	  		    = true;
    		fDelay    		    = 1000;
    		fScore    		    = 0;
    		fBoard.ResetBorad();
    		fEventHandler.fireScoreEvent();
    		fEventHandler.fireTextEvent(" մϴ.");
    		Thread TETRIS = new Thread(fGameRunnable);
    		if(fNetPlaying) netGameStart();
    		try { Thread.sleep(300); } catch (InterruptedException e) { System.err.println("Exception e: " + e); }
    		TETRIS.start();//ӱ  
    	}
    	else fEventHandler.fireTextEvent("    ϴ.");
    }
    public void netGameStart()
    {
    	fNetwork.clientGameStart();
    }
    
    public void startHostGame(){//Ʈũ ϱ ̿ϼκ
    	
    	if(fPlaying == false && fGameReady)
    	{
    		fGameReady = false;
    		fNetwork = GameNetworkModule.getGameNetworkModule(this, true);
    	}
    	else {
    		fGameReady = true;
    		fNetwork.stopServer();    		
    	}
    }
    
    public void startClient(){
    	if(fPlaying == false && fGameReady)
    	{
    		
    		fGameReady = false;
    		fNetwork = GameNetworkModule.getGameNetworkModule(this, false);
    	}
    }
    
    public void useEventHandler(String msg)
    {
    	fEventHandler.fireTextEvent(msg);
    }
    
    public void setNetworkOnOff()
    {	
    	if(fNetPlaying==true) fNetPlaying = false;
    	else fNetPlaying = true;
    }
    
    public void stopGame()
    {
    	fPlaying = false;
    }
	
    public int getColumns()
	{
    	return fBoard.getColumns();
    }
	
	public int getRows()
	{
    	return fBoard.getRows();
    }
    
    public int getPiecefType()
    {
    	return fCurrPiece.getfType();
    }
    
    public int getTempPiecefType()
    {
    	return fTempCurrPiece.getfType();
    }
    
    public int[][] getMap()
    {
    	return fBoard.getMap();
    }
    
    public void move(int direction)
    {
		//System.out.println("Ű  ۵");
		if(fPlaying)
			fCurrPiece.Move(direction);
	}
       
    public class GameThread implements Runnable
    {
    	// ۵ Thread
		public void run() {
								
				boolean loop=true;//ǽ ٴڿ 꿴 ˻
				boolean piece=false;//忡  ǽ ִ ˻
				
				while(fPlaying){
									
					if(piece)	
					{
						
						loop=fCurrPiece.Move(13);	
						//System.out.println("1°  y = "+ fCurrPiece.getCentrePoint().y);
						if(!loop && piece)
						{
							fBoard.AddPiece(fCurrPiece,true);
							
							//@@@@@@@@@@@@@@@@
							//		
							//        ϼ  ǽ   ˻
							//
							final Point center = fCurrPiece.getCentrePoint();//~~ ǽ߽  Ʒ 4ٸ ˻
							int y = center.y + 2;
							
							if(fCurrPiece.getfType() == 2) y++;
							if(y > 20) y = 20;
							
							int removeLineCount = 0;//  Ǿ üũ
							
							for(int cols = center.y - 1;cols < y;cols++){
								boolean same = false;
								int count = 0;
								
								for(int rows = 0;rows < fBoard.getRows();rows++){
									
									if(fBoard.getMap()[ cols ][ rows ]!=fBoard.EMPTY_BLOCK) count++;
									if(count == fBoard.getRows())for(rows = 0;rows < fBoard.getRows();rows++)
									{					
											fBoard.getMap()[ cols ][ rows ]=fBoard.EMPTY_BLOCK ;
											same = true;
									}
									if(same)
									{
										fBoard.removeRow(cols);// ǽ κ 
										fLine++;
										removeLineCount++;
										
										System.out.println("fLine = " + fLine);
										if(fLine%5==0) //5  ӵ 10%
										{											
											fDelay = Math.round(fDelay * 0.9);//̵    !!
											System.out.println("fDelay = " + fDelay);
										}
									}
											
									
								}
							}
							//@					ǽ  ˻ 
							//@
							//@@@@@@@@@@@@@@@@@@@@@@@
							
							if(removeLineCount > 0)
							{
								fScore += removeLineCount * removeLineCount * 100;
								fEventHandler.fireScoreEvent();
							}
				
							removeLineCount = 0;
							
							
							piece = false;
							loop = true;
							
							//System.out.println("fScore = " + fScore);
						}
					}	
					
					
					if(piece==false){
						//׽Ʈ ǽ
						//fCurrPiece=new	TetrisPiece(2,fBoard);
						fCurrPiece=fTempCurrPiece;
			    		fCurrPiece.setCentrePoint(new Point((fBoard.getRows()/2-1),1));
			    		fTempCurrPiece=TetrisPiece.getRandomPiece(fBoard);
			    		
			    		if(fBoard.willFit(fCurrPiece)){
							fBoard.AddPiece(fCurrPiece,true);
							fEventHandler.fireBoardEvent();
			    			piece = true;
				    	}
			    		else
			    		{			    			
			    			System.out.println(" ƿ");
			    			fEventHandler.fireTextEvent("~~ ");
							fBoard.AddPiece(fCurrPiece,true);
							fPlaying=false;	
			    		}
					}
				
				//fBoard.testPrint();
				
				if (fCurrPiece != null) try { Thread.sleep((int)fDelay); } catch (InterruptedException e) { System.err.println("Exception e: " + e); }
			}//while
				
				
		}//run
    	
    }
    public void addBoardListener(BoardListener listener)
    {	
	    fEventHandler.addBoardListener(listener);
    }
   
    public void removeBoardListener(BoardListener listener)
    {
    	fEventHandler.removeBoardListener(listener);
    }
    
    public void addTempBoardListener(BoardListener listener)
    {	
	    fEventHandler.addTempBoardListener(listener);
    }
    public void addScoreListener(ScoreListener listener)
    {	
    	fEventHandler.addScoreListener(listener);
    }
    
    public void addTextListener(TextListener listener)
    {	
    	fEventHandler.addTextListener(listener);
    }

    
    private class EventHandler{
    	private Vector fTextListeners     = new Vector();
    	private Vector fGameListeners     = new Vector();
        private Vector fBoardListeners    = new Vector();
        private Vector fScoreListeners    = new Vector();
        
        public void addTextListener(TextListener listener)
        {	
        	fTextListeners.addElement(listener);
        }
        public void addNetworkTextListener(TextListener listener)
        {
        	fNetwork.addTextListener(listener);
        }
        
        public void addBoardListener(BoardListener listener)
        {	
        	fBoard.addBoardListener(listener);
        }
    
        public void removeBoardListener(BoardListener listener)
        {
            fBoard.removeBoardListener(listener);
        }
        
        public void addTempBoardListener(BoardListener listener)
        {	
            fBoardListeners.addElement(listener);
           
        }
        public void addScoreListener(ScoreListener listener)
        {	
        	fScoreListeners.addElement(listener);
        }
        
        public void fireBoardEvent(){
    		// ǽ GUI ۵
        	BoardEvent event=new BoardEvent(fTempCurrPiece);
    		
    		for (int count = 0; count < fBoardListeners.size(); count++)
                ((BoardListener)fBoardListeners.elementAt(count)).boardChange(event);
    		
    		
        }
        public void fireScoreEvent(){
        	// ۵
        	BoardEvent event=new BoardEvent(fScore);
    		
    		for (int count = 0; count < fScoreListeners.size(); count++)
                ((ScoreListener)fScoreListeners.elementAt(count)).scoreChange(event);
    		
    		
        }
        public void fireTextEvent(String msg){
    		//ؽƮƷ ۵
          	BoardEvent event=new BoardEvent(msg);
    		
    		for (int count = 0; count < fTextListeners.size(); count++)
                ((TextListener)fTextListeners.elementAt(count)).TextChange(event);
    		
    		
        }
    }
}
