
import java.awt.Point;

import java.util.Vector;

public class TetrisBoard {
	public static final int EMPTY_BLOCK = -1;//ʿ ִ κ ŵϴ.
	private Vector  fBoardListeners = new Vector();//
	private int[][] map;
	private int     fColumns;//
    private int     fRows;//
	
    TetrisBoard(int rows, int cols){
		fColumns=cols;// 20
		fRows=rows;// 10
		ResetBorad();
	}
    // EMPTY_BLOCK  
	public void ResetBorad(){
		
		map=new int[fColumns][fRows];
		
		for(int cols=0;cols<fColumns;cols++){
			for(int rows=0;rows<fRows;rows++){
				map[cols][rows]=EMPTY_BLOCK;
			}
		}
	}
	// x,y ġ ִ ǽ ȣ մϴ. 
	public int getPieceAt(int x, int y)    {
    	return map[x][y];
    }
	
	public int getColumns(){
    	return fColumns;
    }
	
	public int getRows(){
    	return fRows;
    }
	
	public int[][] getMap(){
		return map;
	}
	
	//ʿ ǽ Է
	// 迭 ǽ  gType Էմϴ.
	public void AddPiece(TetrisPiece Piece,boolean awt){
			
		if(Piece!=null){
			
			final Point center=Piece.getCentrePoint();
			final Point[] blocks=Piece.getRelativePoints();
		
			for(int count=0;count<4;count++){
					map[center.y + blocks[count].y ][ center.x + blocks[count].x]=Piece.getfType(); 
			}	
		}	
		if(awt) fireBoardEvent();
	}
	//ʿ ǽ 
	// 迭 ǽ  EMPTY_BLOCK Էմϴ.
	public void RemovePiece(TetrisPiece Piece){
		if(Piece!=null){
			
			final Point center=Piece.getCentrePoint();
			final Point[] blocks=Piece.getRelativePoints();
			
			for(int count=0;count<4;count++){
					map[ center.y + blocks[count].y ][ center.x + blocks[count].x ]=EMPTY_BLOCK ; 
			}	
		}		
	}
	//ϼ  ˻մϴ. ̻
	public void removeRow(TetrisPiece Piece){
		if(Piece!=null)
		{
			final Point center = Piece.getCentrePoint();
			int y = center.y + 2;
			
			if(Piece.getfType() == 2) y++;
			if(y > 20) y = 20;
			
			for(int cols = center.y - 1;cols < y;cols++){
				boolean same = false;
				int count = 0;
				for(int rows = 0;rows < fRows;rows++){
					
					if(map[ cols ][ rows ]!=EMPTY_BLOCK) count++;
					if(count == fRows)for(rows = 0;rows < fRows;rows++)
					{					
						 map[ cols ][ rows ]=EMPTY_BLOCK ;
						 same = true;
					}
					if(same) removeRow(cols);
				}
			}
		}
	}
	//ϼǼ    ݴϴ.
	public void removeRow(int col)
	{
		for(int cols = col - 1;cols > 0; cols-- ){
			for(int rows = 0 ; rows < fRows; rows++){
				map[cols+1][rows]=map[cols][rows];
			}
		}
		fireBoardEvent();
	}
	
	// ڸ ׿ ǽ ִ ˻մϴ.
	//׿ ǽ ְų  ڸ  false ȯ˴ϴ.
	public boolean willFit(TetrisPiece Piece){
		
		boolean result=true;
		
		if(Piece!=null){
		
			final Point center = Piece.getCentrePoint();
			final Point[] blocks = Piece.getRelativePoints();
		
			for(int count = 0 ; count < 4 && result == true ; count++){
							
				int x=center.x+blocks[count].x;
				int y=center.y+blocks[count].y;
				//System.out.println("count = "+count +" x = " + x + " " + " y =" + y );
				
				if( x < 0 || x >= fRows || y < 0 || y >=  fColumns )
					result=false;
				
				if( result && map[y][x]!=EMPTY_BLOCK ) result= false;
			}
			
		}
		return result;
	}
	//ܼ׽Ʈ ޼ҵ
	public void testPrint(){
		for(int cols=0;cols<map.length;cols++){
			for(int rows=0;rows<map[0].length;rows++){
				System.out.print(map[cols][rows]);
			}
			System.out.println();
		}
		System.out.println();
	}
	//̿ϼκ ߿ ɼֽϴ.
	public void getFireBoardEvent()//ó ׵θ ׸
	{
		fireBoardEvent();
	}
	
	public void addBoardListener(BoardListener listener)
    {	
        fBoardListeners.addElement(listener);
       
    }

   
    public void removeBoardListener(BoardListener listener)
    {
        fBoardListeners.removeElement(listener);
        
    }
    //Ʈ ȭ ׸ϴ.
	private void fireBoardEvent(){
		BoardEvent event=new BoardEvent(this);
		
		for (int count = 0; count < fBoardListeners.size(); count++)
            ((BoardListener)fBoardListeners.elementAt(count)).boardChange(event);
		
		
    }
	
}//boardŬ
